#!/usr/bin/perl
# Copyright 2001 Sun Microsystems, Inc.  All rights reserved.

### START HARDCODED PATHS
my $Template_dir = '/usr/admserv/templates';

my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = $Debug;
### END HARDCODED PATHS
use Cobalt::Locale;
require Cobalt::Services;
use Cobalt::Netutil;

use CGI;
use Locale::gettext;

# global variables
my $arkeiaScriptURL='/cgi-bin/.cobalt/arkeia/arkeia.cgi';
my $servicesScriptURL='/cgi-bin/.cobalt/services/services.cgi';
my $q=new CGI;
my $page=$q->param( 'page' );
my $locale=Cobalt::Locale->getByHTTPHeader( $ENV{ 'HTTP_ACCEPT_LANGUAGE' } );

if($locale) {
	$ENV{'LANGUAGE'} = $locale->getLocale();
}

if($page ne 'arkeia') {
	genArkeiaPage( \*STDOUT );
} else {
	my $err=0;
	my $info='<IMG SRC="/.cobalt/images/bang" ALIGN=CENTER>';

	# read form input
	my $servername=$q->param('arkeiaserver');
	my $portnumber=$q->param('port');

    	my $ret = Cobalt::Netutil::netutil_dns_verifyhost($servername);

	if ($servername && $ret !~ /^2/) {
		$info .= substr($ret, 4) . '<BR>';
		$err = 1;
	} elsif ($portnumber !~ /^\d+$/ ) {
		$info .= eval('"' . Locale::gettext::dgettext('special-sauce',
  		    'services_arkeia_invalid_portnumber') . '"');
		$err=1;
	} else {
		my $ret = Cobalt::Services::set_arkeia_parameters($servername,
			$portnumber);
		if ($ret!~/^2/o) {
			$info .= substr($ret, 4) . '<BR>';
			$err=1;
		}
	}

	if(!$err) {
		print "location: $servicesScriptURL\n\n";
	} else {
		genArkeiaPage(\*STDOUT, $info);
	}
}

1;


#
# argument 0 is the file handle the page goes to
# argument 1 is the infomation shown to user
#
sub genArkeiaPage {
	my ( $handle, $info )=@_;
	my ( $servername )=Cobalt::Services::get_arkeia_servername();
	my ( $portnumber )=Cobalt::Services::get_arkeia_portnumber();

	# Read in the template
	open( TEMPLATE, "$Template_dir/arkeia.tmpl" )
		  || die "Cannot read $Template_dir/arkeia.tmpl: $!\n";

	print "content-type: text/html \nCache-Control: no-cache\n\n";
	while( <TEMPLATE> ) {
		s/\[SERVERNAME\]/$servername/o;
		s/\[PORTNUMBER\]/$portnumber/o;
		s/\[SCRIPTURL\]/$arkeiaScriptURL/o;
		s/\[SERVICESSCRIPTURL\]/$servicesScriptURL/o;
		s/\[USER_INFO\]/$info/o;

		s/\[str.([^\]]+)\]/Locale::gettext::dgettext("ui", "$1")/geo;
		print $handle $_;
	}
	close TEMPLATE;
}
