#! /usr/bin/perl

# author: Kevin K.M. Chiu
#       Cobalt Networks
# version: 2.0
# date: 7-01-99
#
# Copyright 1999-2000, Cobalt Networks, Inc
# All rights reserved

### START HARDCODED PATHS
my $Template_dir = '/usr/admserv/templates';

my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = $Debug;
### END HARDCODED PATHS
use Cobalt::Locale;
use Cobalt::DiskUtils;

# use strict;
use Locale::gettext;

# global variable
my $locale=Cobalt::Locale->getByHTTPHeader( $ENV{ 'HTTP_ACCEPT_LANGUAGE' } );
if( $locale ) { $ENV{ 'LANGUAGE' }=$locale->getLocale(); }


my $speed;
open(CPU,"/proc/cpuinfo")
    || die "Cannot read /proc/cpuinfo: $!\n";
while (<CPU>)
{
    if (/^cpu MHz\s+:\s([\d\.]+)/o)
    {
        $speed = $1;
        last;
    }
}
close CPU;

my $memory;
open(MEM,"/proc/meminfo")
    || die "Cannot read /proc/meminfo: $!\n";
while (<MEM>)
{
    if (/^MemTotal:\s+(\d+)/o)
    {
	# the total is always less the real amount because kernel use up some memory
	# this algorithm is only good if the kernel don't take up >16MB and
	# memory is blocks of 16MB
	$memory = int (($1+16384)/16384)*16;
#        $memory = int (($1+1024)/1000 ); 
    }
}
close MEM;


my $diskspace;
my %mounts = disk_getmounts;
my $part;
foreach $part (keys %mounts) {
    $diskspace += $mounts{$part}{Size};
}

$diskspace = int($diskspace / 100000) /10;


my $rel;
open(REL,"/etc/cobalt-release")
  || die "Cannot read /etc/cobalt-release: $!\n";
while (<REL>)
{
   if (/release ([\d\.]+)+/o)
   {
       $rel = $1;
   }
}
close REL;

# Read in the template
open( TEMPLATE, "$Template_dir/info.tmpl" )
    || die "Cannot read $Template_dir/info.tmpl: $!\n";

print "content-type: text/html\nCache-Control: no-cache\n\n";

while ( <TEMPLATE> ) {
    s/\[RAM\]/$memory/o;
    s/\[SPEED\]/$speed/o;
    s/\[HD\]/$diskspace/o;
    s/\[REL\]/$rel/o;

    s/\[str.([^\]]+)\]/Locale::gettext::dgettext("ui", "$1")/geo;

    print;
}

close TEMPLATE;

# print "Speed $speed RAM $memory disk $diskspace GB Release $rel\n";

1;
