#!/usr/bin/perl

# $Id: networker.cgi,v 1.4.4.1 2001/02/02 22:12:18 bservies Exp $
#
# Copyright (C) 2001, Sun Microsystems, Inc.
# All rights reserved
#

### START HARDCODED PATHS
my $Template_dir = '/usr/admserv/templates';

my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = $Debug;
### END HARDCODED PATHS
use Cobalt::Locale;
use Cobalt::Services;
use Cobalt::Legato;
use Locale::gettext;
use CGI;

# global variables
my $networker_script_url='/cgi-bin/.cobalt/networker/networker.cgi';
my $networker_page_url='/cgi-bin/.cobalt/services/services.cgi';

my $q=new CGI;
my $locale=Cobalt::Locale->getByHTTPHeader($ENV{'HTTP_ACCEPT_LANGUAGE'});
if ($locale) {
	$ENV{ 'LANGUAGE' }=$locale->getLocale();
}

my $page=$q->param('page');

if ($page ne 'networker') {
	networker_settings_page(\*STDOUT);
} else {
	my $err=0;
	my $info='<IMG SRC="/.cobalt/images/bang" ALIGN=CENTER>';

	# read form input
	my $servers = $q->param('servers');
	my $s_ports = $q->param('service_ports');
	my $c_ports = $q->param('connection_ports');
	my ($result, $server, @serverlist);

	@serverlist = ();
	foreach $server (split /\s+/, join " ", $servers) {
		next if ($server =~ /^\s*$/o);
		push @serverlist, ($server);
	}

	# let the sauce call do the error checking
	$result = Cobalt::Legato::set_config($s_ports, $c_ports, @serverlist);
	if($result !~ /^2/o) {
		$info .= substr($result, 4) . '<BR>';
		$err = 1;
	}

	if (!$err) {
		print "location: $networker_page_url\n\n";
	} else {
		networker_settings_page(\*STDOUT, $info);
	}
}



#
# argument 0 is the file handle the page goes to
# argument 1 is the infomation shown to user
#
sub networker_settings_page {
	my ($handle, $info) = @_;
	my $hostname;
	my $ipaddr;
	my ($s_ports, $c_ports, @servers) = Cobalt::Legato::get_config();
	my $servertext = join "\n", @servers;

	$info = "" unless($info);

	# Read in the template
	open(TEMPLATE, "$Template_dir/networker.tmpl")
	    || die "Cannot read $Template_dir/networker.tmpl: $!\n";

	print "content-type: text/html \nCache-Control: no-cache\n\n";
	while (<TEMPLATE>) {
		s/\[SERVERS\]/$servertext/o;
		s/\[SERVICEPORTS\]/$s_ports/o;
		s/\[CONNECTIONPORTS\]/$c_ports/o;
		s/\[SCRIPTURL\]/$networker_script_url/o;
		s/\[SERVICESPAGEURL\]/$networker_page_url/o;
		s/\[USER_INFO\]/$info/o;
		s/\[str.([^\]]+)\]/Locale::gettext::dgettext("ui", "$1")/geo;

		print $handle $_;
	}
	close TEMPLATE;
}

1;
