#!/usr/bin/perl
#
# Copyright 1998-2000, Cobalt Networks, Inc
# All rights reserved

require Cobalt::Meta::vsite;
require Cobalt::DiskUtils;
### START HARDCODED PATHS
my $Template_dir = '/usr/admserv/templates';
my $Vol_home = 'home';
my $Vol_rootdir = '/vol';
my $Vol_sitepattern = '';

my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = $Debug;
### END HARDCODED PATHS

require Cobalt::Util;
import  Cobalt::Util qw[ MSG_get_ui FILE_lock_r FILE_unlock ];

require CGI;
require Locale::gettext;

my $CK           = qq[CHECKED];
my $Eicon        = qq[<IMG SRC="/.cobalt/images/bang" ALIGN="center">];
my $siteAdd_TMPL = qq[$Template_dir/siteAdd.tmpl];
my $siteAdd_URL  = qq[/cgi-bin/.cobalt/siteAdd/siteAdd.cgi];
my $siteList_URL = qq[/cgi-bin/.cobalt/siteList/siteList.cgi];

use vars qw[ $site $query $locale ];
$locale = Cobalt::Locale->getByHTTPHeader($ENV{'HTTP_ACCEPT_LANGUAGE'});
$site   = new Cobalt::Meta::vsite;
$query  = new CGI;

$query->import_names('Q');
if ($locale) { $ENV{'LANGUAGE'}=$locale->getLocale }

use vars qw[ @webAlias @emailAlias ];
@emailAlias = ();
@webAlias = ();

##
## handle siteadd submit()
if ($Q::page eq 'siteadd') {

    # read form input into Meta::vsite object
    $site->hostname ($Q::hostname);
    $site->domain   ($Q::domain);
    $site->ipaddr   ($Q::ipaddr);
    $site->quota    ($Q::diskquota);
    $site->maxusers ($Q::maxusers);
    $site->ftp      ($Q::ftp);
    $site->ftpquota ($Q::ftpquota);
    $site->ftpusers ($Q::ftpusers);
    $site->shell    ($Q::shell);
    $site->apop     ($Q::apop);
    $site->cgi      ($Q::cgi);
    $site->ssi      ($Q::ssi);
    $site->ssl      ($Q::ssl);
    $site->fpx      ($Q::fpx);
    $site->casp     ($Q::casp);
    $site->php      ($Q::php);
    $site->suspend  ($Q::suspend);
    $site->volume   ($Q::volume);

    @webAlias   = split /[\s,]+/, $Q::webserveralias;
    @emailAlias = split /[\s,]+/, $Q::emailserveralias;

    if (scalar(@webAlias))   { $site->webServerAlias(@webAlias)     }
    if (scalar(@emailAlias)) { $site->emailServerAlias(@emailAlias) }
    if ($site->fpx)          { $site->fpxPassword($Q::fpxpass0)     }

    my($ret,$info) = $site->add();

    if (!$ret) {
	&genSiteAddPage(@$info);
    }
    elsif (scalar(@$info)) {
	print "Location: $siteList_URL\?info=", join('<BR>', @$info), "\n\n";
    }
    else {
	print "Location: $siteList_URL\n\n";
    }

}
else {

    $site->retrieve('default');
    &genSiteAddPage();

}


sub genSiteAddPage
{
    my @info = @_;

    FILE_lock_r($siteAdd_TMPL, *TEMPLATE)
	or die("Cannot read $siteAdd_TMPL : $!\n");

    print "Content-Type: text/html\n";
    print "Cache-Control: no-cache\n\n";

#    my $errstr = '';
#    if (scalar(@info)) { $errstr = $Eicon . join('<BR>', @info) }

    while (<TEMPLATE>) {

	s|\[USER_INFO\]| (scalar(@info)) ? $Eicon . join('<BR>', @info) : q[] |eo;
	s|\[SITELISTSCRIPTURL\]|$siteList_URL|o;
	s|\[SITEADDSCRIPTURL\]|$siteAdd_URL|o;

	s|\[SHELLCHECKED\]| ($site->shell) ? q[CHECKED] : q[] |eo;
	s|\[CASPCHECKED\]|   ($site->casp) ? q[CHECKED] : q[] |eo;
	s|\[PHPCHECKED\]|     ($site->php) ? q[CHECKED] : q[] |eo;
	s|\[APOPCHECKED\]|   ($site->apop) ? q[CHECKED] : q[] |eo;
	s|\[FPXCHECKED\]|     ($site->fpx) ? q[CHECKED] : q[] |eo;
	s|\[CGICHECKED\]|     ($site->cgi) ? q[CHECKED] : q[] |eo;
        s|\[SSICHECKED\]|     ($site->ssi) ? q[CHECKED] : q[] |eo;
	s|\[SSLCHECKED\]|     ($site->ssl) ? q[CHECKED] : q[] |eo;
	s|\[FTPCHECKED\]|     ($site->ftp) ? q[CHECKED] : q[] |eo;

	s|\[WEBSERVERALIAS\]|           join(", ", @webAlias) |eo;
	s|\[EMAILSERVERALIAS\]|       join(", ", @emailAlias) |eo;
	s|\[HOSTNAME\]|                $site->hostname or q[] |eo;
	s|\[DOMAIN\]|                  $site->domain   or q[] |eo;
	s|\[IPADDR\]|                  $site->ipaddr   or q[] |eo;
	s|\[DEFAULTDISKQUOTA\]|        $site->quota    or q[] |eo;
	s|\[MAXFTPUSERS\]|             $site->ftpusers or q[] |eo;
	s|\[MAXUSERS\]|                $site->maxusers or q[] |eo;
	s|\[FTPQUOTA\]|                $site->ftpquota or q[] |eo;

	s|\[VOLLISTCODE\]|             &makeVolList()         |eo;
	s|\[str\.([^\]]+)\]|           &MSG_get_ui($1)        |eog;

	print;

    }
    FILE_unlock(*TEMPLATE);

    exit 1;
}


#
# make a list of all the currently available disks.
#
sub makeVolList
{
    my %mounts = Cobalt::DiskUtils::disk_getmounts($Vol_sitepattern);
    my (%maxfree, %list);
    my ($key, $text);

    foreach $key (keys %mounts) {
	# special case $Vol_home 
	if ($mounts{$key}{MountPoint} =~ /^\/$Vol_home/) {
	    $list{$Vol_home} = $mounts{$key}{Free};
	    if ($list{$Vol_home} > $maxfree{Value}) {
		$maxfree{Disk} = $Vol_home;
		$maxfree{Value} = $list{$Vol_home};
	    }
	    next;
	} 

	# everything else 
	$mounts{$key}{MountPoint} =~ /^$Vol_rootdir\/(\S+)$/o;
	next unless (-e "$mounts{$key}{MountPoint}/.cobaltsig"); 
	$list{$1} = $mounts{$key}{"Free"};
	if ($list{$1} > $maxfree{Value}) {
	    $maxfree{Disk} = $1;
	    $maxfree{Value} = $list{$1};
	}
    }

    $text = "<SELECT NAME=\"volume\">\n";
    foreach $key (sort keys %list) {
	$text .= "<OPTION VALUE=\"$key\" ";
	$text .= "SELECTED" if ($maxfree{Disk} eq $key);
	$text .= ">$key (" . int($list{$key} / 1024);
	$text .= " " . MSG_get_ui("volMBFree");
	$text .= ")</OPTION>\n";
    }
    $text .= "</SELECT>\n";

    return $text;
}

1;
