#!/usr/bin/perl
#
# Copyright 1999-2000, Cobalt Networks, Inc
# All rights reserved
#

require Cobalt::Meta;
require Cobalt::Vsite;
require Cobalt::Locale;
use Cobalt::Util;
use CGI;

use vars qw[ $locale $query $info $sort $order ];

$locale=Cobalt::Locale->getByHTTPHeader($ENV{HTTP_ACCEPT_LANGUAGE});
if ($locale) { $ENV{LANGUAGE}=$locale->getLocale() }

my $URL_siteList      = "/cgi-bin/.cobalt/siteList/siteList.cgi";
my $PATH_search_vsite = "/usr/admserv/html/.cobalt/search/search_vsite.html." . $locale->getLocale();

$query = new CGI;
$query->import_names('Q');

if ($ENV{PARAM_INFO}) {
    $info = $ENV{PARAM_INFO};
} else {
    $info = $Q::info;
}
    
use vars qw[ @where $search ];
$search=0;
@where=();

if ($Q::search eq "yes" && $Q::searchtext ne "") {

    $search = 1;
    push @where, $Q::searchby;

    if ($Q::searchop eq 'match') {
	push @where, '~*';
	push @where, '.*' . $Q::searchtext . '.*';
    }
    elsif ($Q::searchop eq 'nomatch') {
	push @where, '!~*';
	push @where, '.*' . $Q::searchtext . '.*';
    }
    else {
	push @where, $Q::searchop;
	push @where, $Q::searchtext;
    }
}

&genSiteListPage("sort"       => ($Q::sort) ? $Q::sort : "fqdn",
		 "order"      => $Q::order,
		 "info"       => $info,
		 "search"     => $search,
		 "searchop"   => $Q::searchop,
		 "searchby"   => $Q::searchby,
		 "searchtext" => $Q::searchtext,
		 "where"      => \@where);

1;

sub genSiteListPage {
    my (%info)=@_;
    my ($hostname,$domain,$fqdn,$ipaddr,$name,$suspend,$ftp,$ssl,$apop,$fpx,$asp,$php,@o,$obj,$options);
    my ($html,$sorted);
    my ($manageHostX,$removeHostX,$manageHost,$removeHost);
    
    my $script_siteList = "/cgi-bin/.cobalt/siteList/siteList.cgi";
    my $script_siteDel = "/cgi-bin/.cobalt/siteDel/siteDel.cgi";
    my $script_siteAdd = "/cgi-bin/.cobalt/siteAdd/siteAdd.cgi";
    my $script_siteList_options = "/cgi-bin/.cobalt/siteList/options.cgi";
    my $script_siteDefaults = "/cgi-bin/.cobalt/siteDefaults/siteDefaults.cgi";

    my $str_vsite = MSG_get_ui("virtualSiteList");
    my $str_ipaddr = MSG_get_ui("ipAddr");
    my $str_fqdn = MSG_get_ui("hostName");
    my $str_domain = MSG_get_ui("domainName");
    my $str_help = MSG_get_ui("help");
    my $str_saving = MSG_get_ui("saving");
    my $str_virtualSiteList = MSG_get_ui("virtualSiteList");

    my $str_sort_vsite_hostname_asc = MSG_get_ui("sort_vsite_list_hostname_asc");
    my $str_sort_vsite_hostname_desc = MSG_get_ui("sort_vsite_list_hostname_desc");
    my $str_sort_vsite_ipaddr_asc = MSG_get_ui("sort_vsite_list_ipaddr_asc");
    my $str_sort_vsite_ipaddr_desc = MSG_get_ui("sort_vsite_list_ipaddr_desc");

    my $help_vsiteList = MSG_get_ui("vsiteListHelp");
    my $help_ipaddr = MSG_get_ui("ipAddrHelp");
    my $help_fqdn = MSG_get_ui("siteHostNameHelp");
    my $help_access = MSG_get_ui("siteAccessHelp");
    my $help_action = MSG_get_ui("siteManageDelHelp");
    my $help_del_confirm = MSG_get_ui("siteRemoveConfirm");
    my $help_del_confirmnodisk = MSG_get_ui("siteRemoveConfirmNoDisk");
    my $help_sitedefaults = MSG_get_ui("setSiteDefaults");
    my $help_siteadd = MSG_get_ui("addSite");
    my $help_sitelist_options = MSG_get_ui("help_sitelist_options");

    my $javascript = <<END;
top.showInfo( '$info{"info"}' );

var help_vsiteList='$help_vsiteList';
var help_fqdn='$help_fqdn';
var help_ipaddr='$help_ipaddr';
var help_action='$help_action';
var help_access='$help_access';

function delSite( nic ) {
  if( confirm( "$help_del_confirm" ) ) {
    top.showInfo( '<IMG SRC=/.cobalt/images/saving> $str_saving', 0 );
    location="${script_siteDel}?nic="+escape( nic );
  }
}

function delSiteNoDisk( nic ) {
  if( confirm( "$help_del_confirmnodisk" ) ) {
    top.showInfo( '<IMG SRC=/.cobalt/images/saving> $str_saving', 0 );
    location="${script_siteDel}?nic="+escape( nic );
  }
}
END

    my $noIcon='<IMG SRC="/.cobalt/images/blank">';
    my $spacer='<FONT COLOR="#FFFFFF">&nbsp;</FONT>';
    my $suspendIcon='<IMG SRC="/.cobalt/images/suspend_icon_small" ALT="' .
	MSG_get_ui("suspended_site") . '">';
    my $ftpIcon='<IMG SRC="/.cobalt/images/small_file_icon" ALT="' .
	MSG_get_ui("anonymousFTP") . '">';
    my $aspIcon='<IMG SRC="/.cobalt/images/asp-icon" ALT="' .
	MSG_get_ui("asp") . '">';
    my $phpIcon='<IMG SRC="/.cobalt/images/php" ALT="' .
	MSG_get_ui("php") . '">';
    my $fpxIcon='<IMG SRC="/.cobalt/images/counter_icon_small" ALT="' .
	MSG_get_ui("fpxShowSite") . '">';
    my $sslIcon='<IMG SRC="/.cobalt/images/ssl_icon_small" ALT="' .
	MSG_get_ui("activeSSL") . '">';
    my $apopIcon='<IMG SRC="/.cobalt/images/apop_icon_small" ALT="' .
	MSG_get_ui("apopUser") . '">';
    my $bwIcon='<IMG SRC="/.cobalt/images/bwmgmt_icon_small" ALT="' .
	MSG_get_ui("bw_setip") . '">';
    my $deleteIconGray='<IMG SRC="/.cobalt/images/deleteGray">';

    my $meta = new Cobalt::Meta("type" => "bw");
    my %limits = map { $_ => 1; } $meta->SQL(qq[ SELECT DISTINCT name FROM bw ]);

    my @where = ($search) ? @{ $info{"where"} } : undef;
    @o=Cobalt::Meta::query("type"    => "vsite",
			   "keys"    => [ "ipaddr", "fqdn", "name", "ftp", "fpx",
					  "apop", "ssl", "suspend", "casp", "php" ],
			   "sort"    => $info{"sort"},
			   "order"   => $info{"order"},
			   "where"   => \@where);

    my $numfound = scalar(@o);
    my $noSites = MSG_get_ui("search_vsite_nonefound");

    print $query->header(-expires => '-1d',
			 -pragma => 'no-cache');
    print $query->start_html(-title => "$str_virtualSiteList",
			     -BGCOLOR => "#FFFFFF",
			     -script => $javascript);

    my $searchstr;
    if ($info{"search"}) {
	if ($numfound == 1) {
	    $str_vsite = MSG_get_ui("search_vsite_results_1");
	} else {
	    $str_vsite = MSG_get_ui("search_vsite_results", $numfound);
	}
	$searchstr = "&search=yes";
	$searchstr .= "&searchby=" . $info{"searchby"};
	$searchstr .= "&searchop=" . $info{"searchop"};
	$searchstr .= "&searchtext=" . $info{"searchtext"};
    }

    my ($sort_hostname_icon,$sort_ipaddr_icon);

    my $sort_hostname_icon_go = "<A HREF=\"$script_siteList?sort=fqdn$searchstr\" onMouseOver=\"status=\'$str_sort_vsite_hostname_asc\'; return true;\"><IMG SRC=\"/.cobalt/images/both_arrow_icon\" BORDER=0 ALT=\"$str_sort_vsite_hostname_asc\"></A>";
    my $sort_hostname_icon_asc = "<A HREF=\"$script_siteList?sort=fqdn$searchstr\" onMouseOver=\"status=\'$str_sort_vsite_hostname_asc\'; return true;\"><IMG SRC=\"/.cobalt/images/up_arrow_icon\" BORDER=0 ALT=\"$str_sort_vsite_hostname_asc\"></A>";
    my $sort_hostname_icon_desc = "<A HREF=\"$script_siteList?sort=fqdn&order=desc$searchstr\" onMouseOver=\"status=\'$str_sort_vsite_hostname_desc\'; return true;\"><IMG SRC=\"/.cobalt/images/down_arrow_icon\" BORDER=0 ALT=\"$str_sort_vsite_hostname_desc\"></A>";

    my $sort_ipaddr_icon_go = "<A HREF=\"$script_siteList?sort=ipaddr$searchstr\" onMouseOver=\"status=\'$str_sort_vsite_ipaddr_asc\'; return true;\"><IMG SRC=\"/.cobalt/images/both_arrow_icon\" BORDER=0 ALT=\"$str_sort_vsite_ipaddr_asc\"></A>";
    my $sort_ipaddr_icon_asc = "<A HREF=\"$script_siteList?sort=ipaddr$searchstr\" onMouseOver=\"status=\'$str_sort_vsite_ipaddr_asc\'; return true;\"><IMG SRC=\"/.cobalt/images/up_arrow_icon\" BORDER=0 ALT=\"$str_sort_vsite_ipaddr_asc\"></A>";
    my $sort_ipaddr_icon_desc = "<A HREF=\"$script_siteList?sort=ipaddr&order=desc$searchstr\" onMouseOver=\"status=\'$str_sort_vsite_ipaddr_desc\'; return true;\"><IMG SRC=\"/.cobalt/images/down_arrow_icon\" BORDER=0 ALT=\"$str_sort_vsite_ipaddr_desc\"></A>";

    if ($info{"order"}) {
	if ($info{"sort"} eq "fqdn") {
	    $sort_hostname_icon = $sort_hostname_icon_asc;
	    $sort_ipaddr_icon = $sort_ipaddr_icon_go;
	    $str_fqdn = "<B>$str_fqdn</B>";
	    $sorted = "&sort=fqdn";
	} else {
	    $sort_hostname_icon = $sort_hostname_icon_go;
	    $sort_ipaddr_icon = $sort_ipaddr_icon_asc;
	    $str_ipaddr = "<B>$str_ipaddr</B>";
	    $sorted = "&sort=ipaddr";
	}
    } else {
	if ($info{"sort"} eq "fqdn") {
	    $sort_hostname_icon = $sort_hostname_icon_desc;
	    $sort_ipaddr_icon = $sort_ipaddr_icon_go;
	    $str_fqdn = "<B>$str_fqdn</B>";
	    $sorted = "&sort=fqdn&order=desc";
	} else {
	    $sort_hostname_icon = $sort_hostname_icon_go;
	    $sort_ipaddr_icon = $sort_ipaddr_icon_desc;
	    $str_ipaddr = "<B>$str_ipaddr</B>";
	    $sorted = "&sort=ipaddr&order=desc";
	}
    }

    # define html for search
    my $ret = FILE_lock_r($PATH_search_vsite,*SBOX);
    if ($ret) {
	while (<SBOX>) {
	    print;
	}
	FILE_unlock(*SBOX);
    }

    $html = <<END;
<CENTER>
<TABLE BORDER="0" CELLSPACING="0" WIDTH="600">
<TR>
    <TD NOWRAP>
	<CENTER>
	<A HREF="$script_siteDefaults" onMouseOver="status='$help_sitedefaults'; return true;"><IMG SRC="/.cobalt/images/set_virtual_defaults_but" BORDER=0 ALT="$help_sitedefaults"></A>
	<A HREF="$script_siteAdd" onMouseOver="status='$help_siteadd'; return true;"><IMG SRC="/.cobalt/images/add_virtual_site_but" BORDER=0 ALT="$help_siteadd"></A>
	</CENTER>
    </TD>
</TR>
</TABLE>
<TABLE BORDER="1" CELLSPACING="0" WIDTH="600">
    <TR>
	<TH COLSPAN="4" BGCOLOR="#6666CC" ALIGN="CENTER">
	    <A HREF="javascript: top.showInfo( help_vsiteList );" onMouseOver="status='[str.help]'; top.showInfo( help_vsiteList ); return true;"><IMG SRC="/.cobalt/images/question" ALIGN="BOTTOM" BORDER="0"></A>
	    <FONT COLOR="#FFFFFF">$str_vsite</FONT>
        </TH>
    </TR>
END
    ;
    print $html;

    if ($numfound == 0) {
	$html = <<END;
<TR>
    <TD BGCOLOR="#FFFFFF" COLSPAN="4">
	$spacer
	<I>$noSites</I>
    </TD>
</TR>
END
    ;
    } else {
	$html = <<END;
    <TR>
	<TD WIDTH="250" ALIGN="LEFT" NOWRAP>
	    $spacer<A HREF="javascript: top.showInfo( help_fqdn );" onMouseOver="status=' $str_help '; top.showInfo( help_fqdn ); return true;"><IMG SRC="/.cobalt/images/smallest_help_but" ALIGN="BOTTOM" BORDER="0"></A>
	    <FONT SIZE="+1">$str_fqdn</FONT>$sort_hostname_icon
	</TD>
	<TD WIDTH="160" ALIGN="LEFT" NOWRAP>
	    $spacer<A HREF="javascript: top.showInfo( help_ipaddr );" onMouseOver="status=' $str_help '; top.showInfo( help_ipaddr ); return true;"><IMG SRC="/.cobalt/images/smallest_help_but" ALIGN="BOTTOM" BORDER="0"></A>
	    <FONT SIZE="+1">$str_ipaddr</FONT>$sort_ipaddr_icon
        </TD>
	<TD WIDTH="140" ALIGN="CENTER" NOWRAP>
	    <A HREF="javascript: top.showInfo( help_access );" onMouseOver="status=' $str_help '; top.showInfo( help_access ); return true;"><IMG SRC="/.cobalt/images/smallest_help_but" ALIGN="BOTTOM" BORDER="0"></A>
	</TD>
	<TD WIDTH="50" ALIGN="CENTER" NOWRAP>
	    <A HREF="javascript: top.showInfo( help_action );" onMouseOver="status=' $str_help '; top.showInfo( help_action ); return true;"><IMG SRC="/.cobalt/images/smallest_help_but" ALIGN="BOTTOM" BORDER="0"></A>
	</TD>
    </TR>
END
    ;
    }

    print $html;

    foreach (@o) {
	$name = $_->get("name");
	next if ($name eq "default");
	$fqdn = $_->get("fqdn");
	my $tfqdn = $fqdn;
	$ipaddr = $_->get("ipaddr");
	$ftp = $_->get("ftp");
	$fpx = $_->get("fpx");
	$apop = $_->get("apop");
	$ssl = $_->get("ssl");
	$asp = $_->get("casp");
	$php = $_->get("php");
	$suspend = $_->get("suspend");
	my $real_suspend = Cobalt::Vsite::vsite_issuspend($name);

	if ($suspend eq 'on' or $real_suspend) {
	    $fqdn = "<FONT COLOR=\"#AAAAAA\">$fqdn</FONT>";
	    $ipaddr = "<FONT COLOR=\"#AAAAAA\">$ipaddr</FONT>";
	}

	print "<TR VALIGN=MIDDLE>\n";
	print "\t<TD ALIGN=LEFT VALIGN=MIDDLE NOWRAP><FONT COLOR=#FFFFFF>&nbsp;</FONT>$fqdn</TD>\n";
	print "\t<TD ALIGN=LEFT VALIGN=MIDDLE NOWRAP><FONT COLOR=#FFFFFF>&nbsp;</FONT>$ipaddr</TD>\n";
	print "\t<TD ALIGN=LEFT VALIGN=MIDDLE NOWRAP>";
	
	if ($suspend eq 'on' or $real_suspend) {
	    print "<CENTER>" . $suspendIcon . "</CENTER>";
	} else {
	    print $spacer;
	    ($fpx eq 'on') ? print $fpxIcon : print $noIcon;
	    print $spacer;
	    ($asp eq 'on') ? print $aspIcon : print $noIcon;
	    print $spacer;
	    ($php eq 'on') ? print $phpIcon : print $noIcon;
	    print $spacer;
	    ($ftp eq 'on') ? print $ftpIcon : print $noIcon;
	    print $spacer;
	    ($apop eq 'on') ? print $apopIcon : print $noIcon;
	    print $spacer;
	    ($ssl eq 'on') ? print $sslIcon : print $noIcon;
	    print $spacer;
	    (exists($limits{$ipaddr})) ? print $bwIcon : print $noIcon;
	    print $spacer;
	}
	print "</TD>\n\t";

	$manageHostX = MSG_get_ui("manageHostX", $tfqdn);
	$manageHost = '<A HREF="/.cobalt/siteManage/' . $tfqdn . '/" TARGET="_top" onMouseOver="status=\'' . $manageHostX . '\'; return true;"><IMG SRC="/.cobalt/images/manage_but" ALT="' . $manageHostX . '" BORDER="0"></A>';

	$removeHostX = MSG_get_ui("removeHostX", $tfqdn);
	if ($real_suspend lt 0) {
	    $removeHost = '<A HREF="javascript: delSiteNoDisk(\'' . $name . '\');" onMouseOver="status=\'' . $removeHostX . '\'; return true;"><IMG SRC="/.cobalt/images/delete" ALT="' . $removeHostX . '" BORDER="0"></A>';	    
	} else {
	    $removeHost = '<A HREF="javascript: delSite(\'' . $name . '\');" onMouseOver="status=\'' . $removeHostX . '\'; return true;"><IMG SRC="/.cobalt/images/delete" ALT="' . $removeHostX . '" BORDER="0"></A>';
	}

	print '<TD ALIGN=LEFT VALIGN=MIDDLE NOWRAP>';

	print $spacer;
	print $manageHost unless ($real_suspend lt 0);
	print $spacer;
	($name eq "home") ? print $deleteIconGray : print $removeHost;
	print $spacer;
	print "</TD>\n</TR>\n";
    }
    print "\n</TABLE>\n";
    print $query->end_html;
}
