#!/usr/bin/perl

# author: Kevin K.M. Chiu
#       Cobalt Networks
# version: 2.0
# date: 7-6-99
#
# Copyright (C) 1999-2000, Cobalt Networks, Inc
# All rights reserved

### START HARDCODED PATHS
my $BytesPerBlock = '1024';
my $Df_cmd = '/bin/df';
my $Template_dir = '/usr/admserv/templates';

my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = $Debug;
### END HARDCODED PATHS
use Cobalt::Locale;
use Cobalt::User;

# use strict;
use Locale::gettext;

# my $scriptURL="/cgi-bin/.cobalt/userUsage/userUsage.cgi";

my $locale=Cobalt::Locale->getByHTTPHeader( $ENV{ 'HTTP_ACCEPT_LANGUAGE' } );
if( $locale ) { $ENV{ 'LANGUAGE' }=$locale->getLocale(); }


my $loginName=$ENV{ REMOTE_USER };

# force login
# if( !$loginName ) { print "location: $scriptURL\n\n"; }

# read total disk space
my $totalFree=0;
open( DF,"$Df_cmd |") || die "Can't execute $Df_cmd: $!\n";
while ( <DF> ) {
    if ( /^\/dev\/.d/o ) {
	# only free space on home is truly free
	if( $_=~/\/home/o ) {
	    my @info=split(/\s+/o);
	    $totalFree+=$info[ 3 ];
	}
    }
}
close DF;


my( $userQuota, $userUsage )=( user_show( $loginName ) )[ 2, 3 ];

# block to MB
$totalFree*=$BytesPerBlock/1048576;
$userQuota*=$BytesPerBlock/1048576;
$userQuota=int( $userQuota*10 )/10;
$userUsage*=$BytesPerBlock/1048576;
$userUsage=int( $userUsage*10 )/10;

# Note: disk usage can be larger than quota because it is a soft quota
my $userFree;
if( $userQuota==0 ) {
    $userFree=$totalFree;
}
else {
    $userFree=( $userQuota>$userUsage )?$userQuota-$userUsage:0;
    if( $userFree>$totalFree ) { $userFree=$totalFree; }
}
$userFree=int( $userFree*10 )/10;

my $userUsageBar=int( $userUsage/( $userFree+$userUsage )*100 );
my $userFreeBar=100-$userUsageBar;

# Note: this is only valid if userUsageBar has a width of 100
my $userUsagePercentage=$userUsageBar;

my $userQuotaField;
if( $userQuota==0 ) {
    $userQuotaField = "<I>".eval("\"".Locale::gettext::dgettext("ui", "unlimited")."\"")."</I>";
    $userFree = "<I>".eval("\"".Locale::gettext::dgettext("ui", "unlimited")."\"")."</I>";
    $userUsagePercentage=0;
} 
else { 
    $userQuotaField = $userQuota; 
}

my $usageBarField;
if( $userUsageBar>0 ) { $usageBarField .= "<IMG SRC=\"/.cobalt/images/amber_color1\" WIDTH=$userUsageBar HEIGHT=10 BORDER=0>"; }
if( $userFreeBar>0 ) {  $usageBarField .= "<IMG SRC=\"/.cobalt/images/green_color\" WIDTH=$userFreeBar HEIGHT=10 BORDER=0>"; }
$usageBarField.="<FONT COLOR=#FFFFFF>&nbsp;</FONT>$userUsagePercentage%";

# Read in the template
open( TEMPLATE, "$Template_dir/userUsage.tmpl" )
    || die "Cannot read $Template_dir/userUsage.tmpl: $!\n";

print "content-type: text/html \nCache-Control: no-cache\n\n";

while( <TEMPLATE> ) {
    s/\[USERUSAGE\]/$userUsage/o;
    s/\[USERFREE\]/$userFree/o;
    s/\[USERQUOTA\]/$userQuotaField/o;
    s/\[USAGE_BAR\]/$usageBarField/o;

    s/\[str.([^\]]+)\]/Locale::gettext::dgettext("ui", "$1")/geo;

    print;
}
close TEMPLATE;


1;
