#!/usr/bin/perl
#
# Copyright 1999-2000, Cobalt Networks, Inc
# All rights reserved

### START HARDCODED PATHS
my $AdminCGIs_dir = '/usr/admserv/cgi-bin/.cobalt';
my $AdminPages_dir = '/usr/admserv/html/.cobalt';
my $AdminServer_dir = '/usr/admserv';
my $AdminUser = 'admin';
my $BytesPerBlock = '1024';
my $FTPAnonQuota = '20';
my $FTPUsersMax = '10';
my $Group_skel = '/etc/skel/group';
my $Htgroup_dir = '/home/sites';
my $Lcdshowscript = '/etc/rc.d/init.d/lcd-showip';
my $Lockdir = '/etc/locks';
my $MainGroup = 'home';
my $UserCGIs_dir = '/usr/httpd/cgi-bin/cobalt';
my $UserPages_dir = '/usr/httpd/html/cobalt';
my $Webdir = 'web';
my %Features = ('networker','1','telnetConfig','1','dhcpd','0','pagebuilder','0','www','1','mx','1','gated','1','dns','1','nfs','0','securetty','1','arkeia','1','atalk','0','fpx','1','siteAdminRedirect','1','users','1','ntp','0','mon_textdb_only','0','search','0','anonFTP','1','specialHomeSkel','0','viewGroups','0','cobaltHomePage','0','netbackup','1','warnRootOnly','1','vsites','1','pam','1','discuss','0','docorg','0','groups','1','smb','0','mail','1','nat','0','asp','1','squid','0','autoGenWebUsage','0','cobaltRedirect','0','backups','1','vmachine','1','mon_port_testing','1','viewUsers','0','usersCGIInWizard','1','aspAdmin','1','privatedirs','0','telnetDefault','1','ssl','0','siteManagement','1','adm','1','mgmt','0','bind8','1','throttle','0','personalRedirect','1','webRequests','1','usersAddUser','0','adminRedirect','1','quotas','1','snmp','1','defaultUserNameGen','1','groupdirs','1','proftpd','1');

my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = $Debug;
### END HARDCODED PATHS
require Cobalt::Admserv;
import Cobalt::Admserv qw( admserv_set_access );
require Cobalt::Locale;
require Cobalt::Netutil;
require Cobalt::Vsite;
require Cobalt::Ftp;
require Cobalt::List;
require Cobalt::Quota;
require Cobalt::Util;
import Cobalt::Util qw( FILE_lock_w FILE_unlock );
require Cobalt::Meta;
require Cobalt::Meta::vsite;

use Fcntl qw( O_RDWR O_CREAT );

my $localeObj=new Cobalt::Locale;
my $locale=$localeObj->get_locale;

# Update httpd to the current hostname, restarts httpd
&Cobalt::Vsite::vsite_sync();

# to display the host name and IP address on LCD
qx($Lcdshowscript) if (-x $Lcdshowscript);

# Configure anonymous ftp
if ($Features{anonFTP}) {
    # The IP address for $MainGroup is ignored since proftpd.conf contains
    #   no virtual hosting data for $Netif
    # ftp_config configures directories and user accounts automatically
    &Cobalt::Ftp::ftp_config('27.27.27.27',1,0,$MainGroup,$FTPUsersMax,$FTPAnonQuota*=1048576/$BytesPerBlock);
}
                
# restrict access
# be careful to set these in order so that the browser do not ask for password more than once
admserv_set_access( "$AdminPages_dir/admin/", 'admin' );
admserv_set_access( "$AdminPages_dir/alert/", 'admin' );
admserv_set_access( "$AdminPages_dir/cpuUsage/", 'admin' );
admserv_set_access( "$AdminPages_dir/diskUsage/", 'site-admin' );
admserv_set_access( "$AdminPages_dir/network/", 'admin' );
admserv_set_access( "$AdminPages_dir/raidUsage/", 'admin' );
admserv_set_access( "$AdminPages_dir/reboot/", 'admin' );
admserv_set_access( "$AdminPages_dir/services/", 'admin' );
admserv_set_access( "$AdminPages_dir/shutdown/", 'admin' );
admserv_set_access( "$AdminPages_dir/siteAdd/", 'admin' );
admserv_set_access( "$AdminPages_dir/siteDefaults/", 'admin' );
admserv_set_access( "$AdminPages_dir/siteList/", 'admin' );
admserv_set_access( "$AdminPages_dir/sysManage/", 'admin' );
admserv_set_access( "$AdminPages_dir/sysSettings/", 'admin' );
admserv_set_access( "$AdminPages_dir/webUsage/", 'site-admin' );
admserv_set_access( "$AdminPages_dir/wizard/", 'admin' );

admserv_set_access( "$AdminPages_dir/appletData/", 'none' );
admserv_set_access( "$AdminPages_dir/about/", 'none' );
admserv_set_access( "$AdminPages_dir/error/", 'none' );
admserv_set_access( "$AdminPages_dir/htedit/", 'valid' );
admserv_set_access( "$AdminPages_dir/images/", 'none' );
admserv_set_access( "$AdminPages_dir/help/", 'none' );
admserv_set_access( "$AdminPages_dir/info/", 'none' );
admserv_set_access( "$AdminPages_dir/install/", 'admin' );
admserv_set_access( "$AdminPages_dir/javaScript/", 'valid' );
admserv_set_access( "$AdminPages_dir/personal/", 'none' );
admserv_set_access( "$AdminPages_dir/shared/", 'none' );
admserv_set_access( "$AdminPages_dir/siteManage/", 'none' );

admserv_set_access( "$AdminCGIs_dir/admin/", 'admin' );
admserv_set_access( "$AdminCGIs_dir/cpuUsage/", 'admin' );
admserv_set_access( "$AdminCGIs_dir/diagDump/", 'admin' );
admserv_set_access( "$AdminCGIs_dir/disk/", 'admin' );
admserv_set_access( "$AdminCGIs_dir/diskUsage/", 'site-admin' );
admserv_set_access( "$AdminCGIs_dir/dns/", 'admin' );
admserv_set_access( "$AdminCGIs_dir/dnsUsage/", 'admin' );
admserv_set_access( "$AdminCGIs_dir/emailUsage/", 'admin' );
admserv_set_access( "$AdminCGIs_dir/fileUsage/", 'admin' );
admserv_set_access( "$AdminCGIs_dir/info/", 'site-admin' );
admserv_set_access( "$AdminCGIs_dir/install/", 'admin' );
admserv_set_access( "$AdminCGIs_dir/installReplace/", 'admin' );
admserv_set_access( "$AdminCGIs_dir/mailListAdd/", 'site-admin' );
admserv_set_access( "$AdminCGIs_dir/mailListDel/", 'site-admin' );
admserv_set_access( "$AdminCGIs_dir/mailListList/", 'site-admin' );
admserv_set_access( "$AdminCGIs_dir/mailListMod/", 'site-admin' );
admserv_set_access( "$AdminCGIs_dir/memUsage/", 'admin' );
admserv_set_access( "$AdminCGIs_dir/network/", 'admin' );
admserv_set_access( "$AdminCGIs_dir/networker/", 'admin' );
admserv_set_access( "$AdminCGIs_dir/networkUsage/", 'admin' );
admserv_set_access( "$AdminCGIs_dir/reboot/", 'admin' );
admserv_set_access( "$AdminCGIs_dir/bw/", 'admin' );
admserv_set_access( "$AdminCGIs_dir/relay/", 'admin' );
admserv_set_access( "$AdminCGIs_dir/services/", 'admin' );
admserv_set_access( "$AdminCGIs_dir/siteAdd/", 'admin' );
admserv_set_access( "$AdminCGIs_dir/siteDefaults/", 'admin' );
admserv_set_access( "$AdminCGIs_dir/siteDel/", 'admin' );
admserv_set_access( "$AdminCGIs_dir/siteDiskUsage/", 'site-admin' );
admserv_set_access( "$AdminCGIs_dir/siteFTP/", 'site-admin' );
admserv_set_access( "$AdminCGIs_dir/siteList/", 'admin' );
admserv_set_access( "$AdminCGIs_dir/siteMod/", 'site-admin' );
admserv_set_access( "$AdminCGIs_dir/siteSSL/", 'site-admin' );
admserv_set_access( "$AdminCGIs_dir/siteUserAdd/", 'site-admin' );
admserv_set_access( "$AdminCGIs_dir/siteUserDefaults/", 'site-admin' );
admserv_set_access( "$AdminCGIs_dir/siteUserDel/", 'site-admin' );
admserv_set_access( "$AdminCGIs_dir/siteUserEmail/", 'site-admin' );
admserv_set_access( "$AdminCGIs_dir/siteUserList/", 'site-admin' );
admserv_set_access( "$AdminCGIs_dir/siteUserMod/", 'site-admin' );
admserv_set_access( "$AdminCGIs_dir/smb/", 'admin' );
admserv_set_access( "$AdminCGIs_dir/snmp/", 'admin' );
admserv_set_access( "$AdminCGIs_dir/snmpUsage/", 'admin' );
admserv_set_access( "$AdminCGIs_dir/sysSettings/", 'admin' );
admserv_set_access( "$AdminCGIs_dir/telnetUsage/", 'admin' );
admserv_set_access( "$AdminCGIs_dir/time/", 'admin' );
admserv_set_access( "$AdminCGIs_dir/tools/", 'admin' );
admserv_set_access( "$AdminCGIs_dir/totUsage/", 'admin' );
admserv_set_access( "$AdminCGIs_dir/webLog/", 'site-admin' );
admserv_set_access( "$AdminCGIs_dir/webUsage/", 'admin' );
admserv_set_access( "$AdminCGIs_dir/wizard/", 'admin' );
admserv_set_access( "$AdminCGIs_dir/userDefaults/", 'admin' );
admserv_set_access( "$AdminCGIs_dir/arkeia/", 'admin' );
admserv_set_access( "$AdminCGIs_dir/alert/", 'admin' );
admserv_set_access( "$AdminCGIs_dir/alertSignal/", 'admin' );
admserv_set_access( "$AdminCGIs_dir/backup/", 'valid' );
admserv_set_access( "$AdminCGIs_dir/email/", 'valid' );
admserv_set_access( "$AdminCGIs_dir/profileMod/", 'valid' );
admserv_set_access( "$AdminCGIs_dir/userMod/", 'valid' );
admserv_set_access( "$AdminCGIs_dir/userUsage/", 'valid' );

admserv_set_access( "$UserCGIs_dir/search/private/", 'valid' );

# cgi-bin/register, html/register and cgi-bin/message access are set by register.cgi and register_later.cgi

# owned by
my $gid = (getgrnam($MainGroup))[2];
my $uid = (getpwnam($AdminUser))[2];

# default object
my $obj;
$obj = new Cobalt::Meta::vsite(name => "default");
$obj->save;

# get host/domain/ip for main site for database
my $ipaddr   = (&Cobalt::Network::net_get_ipaddr())[0];
my $hostname = &Cobalt::Network::net_get_hostname();
my $fqdn     = &Cobalt::Netutil::netutil_get_fulldomain();
$fqdn =~ /^$hostname\.(.*)/;
my $domain = $1;

# initialize database for home site
$obj = new Cobalt::Meta::vsite( name     => "home",
			        quota    => 1000,
			        maxusers => 100,
			        ipaddr   => $ipaddr,
			        domain   => $domain,
			        hostname => $hostname,
			        fqdn     => $fqdn );
$obj->save;
$obj->DESTROY;

$obj = new Cobalt::Meta( type     => "users",
			 name     => "admin",
			 fullname => "Administrator",
			 aliases  => undef,
			 altname  => undef,
			 vsite    => undef,
			 forward  => undef,
			 quota    => 0,
			 uid      => $uid,
			 admin    => t,
			 apop     => f,
			 suspend  => f,
			 vacation => f,
			 shell    => f,
			 fpx      => f );
$obj->save;
$obj->DESTROY;

$obj = new Cobalt::Meta( type     => "users",
			 name     => "default",
			 fullname => undef,
			 aliases  => undef,
			 altname  => undef,
			 vsite    => undef,
			 forward  => undef,
			 quota    => 25,
			 uid      => 99,
			 admin    => f,
			 apop     => f,
			 suspend  => f,
			 vacation => f,
			 shell    => f,
			 fpx      => f );
$obj->save;
$obj->DESTROY;

$obj = new Cobalt::Meta( type      => "bw",
			 name      => "default",
			 bwlimit   => undef,
			 port      => undef,
			 method    => "ip",
			 protocol  => "tcp",
			 direction => "w" );
$obj->save;
$obj->DESTROY;

# set quota for main site
&Cobalt::Quota::setqlim("$Htgroup_dir/$MainGroup",$gid,1024000,1024001,1);

# create a virtual list server for the main site
&Cobalt::List::list_create_virtual($MainGroup, $fqdn);

# restrict userAdd access according to access mode
admserv_set_access("$AdminCGIs_dir/userAdd", 'admin');
admserv_set_access("$AdminPages_dir/userAdd", 'admin');
admserv_set_access("$UserPages_dir/userAddU", 'admin');

# clean up wizard pages
unlink("$Htgroup_dir/$MainGroup/$Webdir/index.html");
unlink("$AdminServer_dir/html/index.html");

# make main page
qx(cp -f $Group_skel/$MainGroup/$locale/$Webdir/index.html $Htgroup_dir/$MainGroup/$Webdir/index.html);

# rotate the main sites web access log
&Cobalt::Vsite::vsite_set_logrotate($MainGroup,30);

# ManageRaQ wants and needs if enabled
if ($Features{'mgmt'}) {

    my $base_page = <<END;
<HTML><HEAD>
<META HTTP-EQUIV="Refresh" CONTENT="0;URL=https://${fqdn}:449/">
</HEAD></HTML>
END

    if (FILE_lock_w("$Lockdir/index.html", *PAGE)) {
        print PAGE $base_page;
	FILE_unlock(*PAGE);
        qx(mv -f $Lockdir/index.html $AdminPages_dir/about/index.html);
    }
}

# Permission? Ah, let the admin have it.
chown($uid, $gid, "$Htgroup_dir/$MainGroup/$Webdir/index.html");
chmod(0664, "$Htgroup_dir/$MainGroup/$Webdir/index.html");

# remove swatch's lockfile
unlink("/etc/locks/LCK..swatch");

# redirect to cobalt homepage
if ($Features{'cobaltHomePage'}) {
    print "Location: /.user/cobalt/\n\n";
}

1;
